// dividuums brainfuck interpreter 0.1
//
// ---------------------------------
//
// Copyright (c) 2000 Florian Wesch <fw@dividuum.de>. All Rights Reserved.     
//                                                                              
// Permission to use, copy, modify, and distribute this software                
// and its documentation for any purposes and without               
// fee is hereby granted provided that this copyright notice                    
// appears in all copies.                                                       
//                                                                              
// Of course, this soft is provided "as is" without express or implied          
// warranty of any kind.        
//
// -----------------------------
//
// Version 0.1
// - enthlt wahrscheinlich noch ein paar bugs
// - u.U. nicht standar{d|t}-konform (siehe FIXME)
//   ? Welchen Datentyp haben die Speicherzellen
//   ? Was passiert bei overflows (momentan wird mit OVERFLOW/UNDERFLOW abgebrochen
//
// TODO
// - ext/bf fr PHP
// - Cache fr Sprnge (FuckCache) :-)
// - "," als Eingabe wird noch nicht untersttzt

#include <stdio.h>
#include <stdlib.h>


// Fehlercodes
#define SUCCESS 0
#define UNMATCHEDOPEN 1
#define UNMATCHEDCLOSE 2
#define RESULTFULL 3
#define OVERFLOW 4
#define UNDERFLOW 5
#define UNKNOWNOPCODE 6

// Opcodes
#define OPINCV '+'
#define OPLOOPS '['
#define OPDECV '-'
#define OPLOOPE ']'
#define OPINCP '>'
#define OPDECP '<'
#define OPOUT '.'
#define OPIN ','

int executebf(char *programm, char *result, int maxresult,int memsize) {
    
    unsigned char *memory;
   
    int progsize=strlen(programm); // Programmgrsse

    int  ip=0; // instructionpointer
    int  mp=0; // memorypointer
    
    int  status=0; // interpreterstatus

    int  depth; // fr die [ Suche
    int  suchip;   

    //int read=0; // gelesene bytes der eingabe
    int written=0; // geschriebene bytes

    int runtime=0;

    memory=(unsigned char*)calloc(memsize,1); 

    while (programm[ip]) {
        //printf("ip=%d programm[ip]=%c mp=%d memory[mp]=%d\n",ip,programm[ip],mp,memory[mp]);
        switch (programm[ip]) {
            case OPINCV: // Wert an aktueller Speicherstelle erhhen
                if (memory[mp]==255) { // FIXME Overflows?
                    status=OVERFLOW;
                    goto raus;
                }
                memory[mp]++;
                break;
            case OPDECV: // Wert an aktueller Speicherstelle erniedrigen
                if (memory[mp]==0) { // FIXME Was ist mit overflows?
                    status=UNDERFLOW;
                    goto raus;
                }
                memory[mp]--;
                break;
            case OPINCP: // Speicherzellenpointer erniedrigen
                mp++;
                if (mp>memsize) // FIXME Ok so? 
                    mp=memsize;
                break;
            case OPDECP:
                mp--;
                if (mp<0) // FIXME Ok so?
                    mp=0;
                break;
            case OPLOOPS: // Zu zugehrigem ] springen
                if (memory[mp]==0) { 
                    //printf("sprung zu --> ]\n");
                    depth=1;
                    suchip=ip+1;

                    while (suchip<progsize && depth>0) { // FIXME verschnern
                        //printf("suchip=%d depth=%d programm[suchip]=%c\n",suchip,depth,programm[suchip]);
                        switch (programm[suchip]) {
                            case OPLOOPE: depth--; break;
                            case OPLOOPS: depth++; break;
                        }
                        suchip++;
                    }

                    if (depth==0) {
                        ip=suchip-1;
                    } else {
                        status=UNMATCHEDOPEN;
                        goto raus;
                    }
                } else {
                    //printf("kein sprung\n");
                }
                break;
            case OPLOOPE: // Zu zugehrigem [ springen
                //printf("sprung zu [ <---\n");
                depth=1;
                suchip=ip-1;
                while ((suchip>=0) && (depth>0)) { // FIXME besser machen 
                    //printf("suchip=%d depth=%d programm[suchip]=%c\n",suchip,depth,programm[suchip]);
                    switch (programm[suchip]) {
                        case OPLOOPE: depth++; break;
                        case OPLOOPS: depth--; break;
                    }
                    suchip--;
                }
                                      
                if (depth==0) {
                    ip=suchip;
                } else {
                    status=UNMATCHEDCLOSE;
                    goto raus;
                }
                break;
            case OPOUT:
                //printf("AUSGABE memory[%d]=%c (%d)\n",mp,memory[mp],memory[mp]);
                if (written<maxresult-1) {
                    result[written]=memory[mp];
                    written++;
                } else {
                    status=RESULTFULL;
                    goto raus;
                }
                break;
            default:
                // Unbekannte Opcodes berspringen
                //status=UNKNOWNOPCODE;
                //goto raus;
        }
        runtime++;
        ip++;
    }
    //printf("SUCCESS output %d\n",written);
    status=SUCCESS;
    result[++written]=0;
    
raus:
    //printf("%d\n",runtime);
    free(memory);
    return status;
}

#define MEMSIZE 4000

int main(int argc, char **argv) { 
    char *result=(char*)malloc(MEMSIZE);
    int status;

    if (argc!=2) {                                                              
        printf("syntax %s Brainfucksource\n",argv[0]);                                    
        exit(1);                                                                
    } 

    status=executebf(argv[1],result,MEMSIZE,5000); 

    printf("%s\n",result);

    return status;
}

    
